// Auto-generated. Do not edit!

// (in-package fetch_auto_dock_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class DockGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.dock_pose = null;
      this.dock_id = null;
      this.use_move_base = null;
    }
    else {
      if (initObj.hasOwnProperty('dock_pose')) {
        this.dock_pose = initObj.dock_pose
      }
      else {
        this.dock_pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('dock_id')) {
        this.dock_id = initObj.dock_id
      }
      else {
        this.dock_id = '';
      }
      if (initObj.hasOwnProperty('use_move_base')) {
        this.use_move_base = initObj.use_move_base
      }
      else {
        this.use_move_base = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DockGoal
    // Serialize message field [dock_pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.dock_pose, buffer, bufferOffset);
    // Serialize message field [dock_id]
    bufferOffset = _serializer.string(obj.dock_id, buffer, bufferOffset);
    // Serialize message field [use_move_base]
    bufferOffset = _serializer.bool(obj.use_move_base, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DockGoal
    let len;
    let data = new DockGoal(null);
    // Deserialize message field [dock_pose]
    data.dock_pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [dock_id]
    data.dock_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [use_move_base]
    data.use_move_base = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.dock_pose);
    length += object.dock_id.length;
    return length + 5;
  }

  static datatype() {
    // Returns string type for a message object
    return 'fetch_auto_dock_msgs/DockGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3802143c05afa4995a977654bae73c88';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Inital pose of the dock, usually map referenced
    # If the header is empty, or quaternion = (0 0 0 0), then
    #   the intial dock pose will be straight ahead of the robot
    geometry_msgs/PoseStamped dock_pose
    
    # Specify an (optional) name for the dock
    string dock_id
    
    # We can optionally request that the docking node call on the
    # navigation stack to get near the dock if we are too far away
    bool use_move_base
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DockGoal(null);
    if (msg.dock_pose !== undefined) {
      resolved.dock_pose = geometry_msgs.msg.PoseStamped.Resolve(msg.dock_pose)
    }
    else {
      resolved.dock_pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.dock_id !== undefined) {
      resolved.dock_id = msg.dock_id;
    }
    else {
      resolved.dock_id = ''
    }

    if (msg.use_move_base !== undefined) {
      resolved.use_move_base = msg.use_move_base;
    }
    else {
      resolved.use_move_base = false
    }

    return resolved;
    }
};

module.exports = DockGoal;
